.\" Copyright (c) 2001 Wind River Systems
.\" Copyright (c) 1997, 1998, 1999, 2000, 2001
.\"	Bill Paul <wpaul@windriver.com>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man4/bge.4,v 1.1.2.4 2003/02/17 21:20:39 trhodes Exp $
.\" $DragonFly: src/share/man/man4/bge.4,v 1.9 2008/03/16 15:50:22 hasso Exp $
.\"
.Dd March 4, 2007
.Dt BGE 4
.Os
.Sh NAME
.Nm bge
.Nd "Broadcom BCM570x PCI gigabit ethernet adapter driver"
.Sh SYNOPSIS
.Cd "device miibus"
.Cd "device bge"
.Sh DESCRIPTION
The
.Nm
driver provides support for various NICs based on the Broadcom BCM570x
family of gigabit ethernet controller chips, including the
following:
.Pp
.Bl -bullet -compact
.It
3Com 3c996-T (10/100/1000baseT)
.It
Dell PowerEdge 2550 integrated BCM5700 NIC (10/100/1000baseT)
.It
Netgear GA302T (10/100/1000baseT)
.It
SysKonnect SK-9D21 (10/100/1000baseT)
.It
SysKonnect SK-9D41 (1000baseSX)
.El
.Pp
All of these NICs are capable of 10, 100 and 1000Mbps speeds over CAT5
copper cable, except for the SysKonnect SK-9D41 which supports only
1000Mbps over multimode fiber.
The BCM570x builds upon the technology of the Alteon Tigon II.
It has two R4000 CPU cores and is PCI v2.2 and PCI-X v1.0 compliant.
It supports IP, TCP
and UDP checksum offload for both receive and transmit,
multiple RX and TX DMA rings for QoS applications, rules-based
receive filtering, and VLAN tag stripping/insertion as well as
a 256-bit multicast hash filter.
Additional features may be
provided via value-add firmware updates.
The BCM570x supports TBI (ten bit interface) and GMII
transceivers, which means it can be used with either copper or 1000baseX
fiber applications.
Note however the device only supports a single
speed in TBI mode.
.Pp
Most cards also use the Broadcom BCM5401 or BCM5411 10/100/1000
copper gigabit transceivers,
which support autonegotiation of 10, 100 and 1000mbps modes in
full or half duplex.
.Pp
The BCM5700 also supports jumbo frames, which can be configured
via the interface MTU setting.
Selecting an MTU larger than 1500 bytes with the
.Xr ifconfig 8
utility configures the adapter to receive and transmit jumbo frames.
Using jumbo frames can greatly improve performance for certain tasks,
such as file transfers and data streaming.
.Pp
The
.Nm
driver supports the following media types:
.Bl -tag -width ".Cm 10baseT/UTP"
.It Cm autoselect
Enable autoselection of the media type and options.
The user can manually override
the autoselected mode by adding media options to
.Xr rc.conf 5 .
.It Cm 10baseT/UTP
Set 10Mbps operation.
The
.Xr ifconfig 8
.Ic mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 100baseTX
Set 100Mbps (fast ethernet) operation.
The
.Xr ifconfig 8
.Ic mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 1000baseT
Set 1000baseT operation over twisted pair.
.Cm full-duplex
and
.Cm half-duplex
modes are supported.
.It Cm 1000baseSX
Set 1000Mbps (gigabit ethernet) operation.
Both
.Cm full-duplex
and
.Cm half-duplex
modes are supported.
.El
.Pp
The
.Nm
driver supports the following media options:
.Bl -tag -width ".Cm full-duplex"
.It Cm full-duplex
Force full duplex operation.
.It Cm half-duplex
Force half duplex operation.
.El
.Pp
The
.Nm
driver also supports one special link option for 1000baseT cards:
.Bl -tag -width ".Cm link0"
.It Cm link0
With 1000baseT cards, establishing a link between two ports requires
that one port be configured as a master and the other a slave.
With autonegotiation,
the master/slave settings will be chosen automatically.
However when manually selecting the link state, it is necessary to
force one side of the link to be a master and the other a slave.
The
.Nm
driver configures the ports as slaves by default.
Setting the
.Cm link0
flag with
.Xr ifconfig 8
will set a port as a master instead.
.El
.Pp
For more information on configuring this device, see
.Xr ifconfig 8 .
.Sh TUNABLES
.Bl -tag -width ".Va hw.bge.fake_autoneg"
.It Va hw.bge.fake_autoneg
Set to 1 for some
.Tn IBM
blade servers,
if auto-negotiation between the onboard
.Nm
and the switch module is broken.
Disabled by default.
.El
.Sh DIAGNOSTICS
.Bl -diag
.It "bge%d: couldn't map memory"
A fatal initialization error has occurred.
.It "bge%d: couldn't map ports"
A fatal initialization error has occurred.
.It "bge%d: couldn't map interrupt"
A fatal initialization error has occurred.
.It "bge%d: no memory for softc struct!"
The driver failed to allocate memory for per-device instance information
during initialization.
.It "bge%d: failed to enable memory mapping!"
The driver failed to initialize PCI shared memory mapping.
This might
happen if the card is not in a bus-master slot.
.It "bge%d: no memory for jumbo buffers!"
The driver failed to allocate memory for jumbo frames during
initialization.
.It "bge%d: watchdog timeout"
The device has stopped responding to the network, or there is a problem with
the network connection (cable).
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr miibus 4 ,
.Xr netintro 4 ,
.Xr ng_ether 4 ,
.Xr vlan 4 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
device driver first appeared in
.Fx 4.5 .
.Sh AUTHORS
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@windriver.com .
